#NAME: SLENDER
#AUTHOR: JAKUB KUPIKOWSKI
#DESCRIPTION: BAKES LIGHTMAP TO SKETCHUP TEXTURES IN BLENDER USING COLLADA EXPORT/IMPORT

require 'sketchup.rb'

#DEFINA LOCAL VARIABLES
model = Sketchup.active_model

#DEFINE FILENAMES
batch_file_name = 'slender.bat'
model_file_name = 'slender.dae'
log_file_name = 'slender.log'
sun_file_name = 'slender.sun'

#DEFINE PATHS
plugin_path = File.dirname(__FILE__)
model_path = plugin_path
batch_path = plugin_path
log_path = plugin_path
sun_path = plugin_path
#model_path = model.path
#if model_path == ''  
	#model_path = File.dirname(__FILE__)
#else
	#model_path = File.dirname(model_path)
#end

#EXPORT COLLADA FILE
options_hash = { :triangulated_faces => true,
                 :doublesided_faces => false,
                 :edges => false,
                 :author_attribution => false,
                 :texture_maps => true,
                 :selectionset_only => false,
                 :preserve_instancing => false }
				 
model_file_path = model_path + '/' + model_file_name
status = model.export model_file_path, options_hash

#EXPORT SUN DIRECTION
sun_direction = model.shadow_info['SunDirection'].to_a.join(' ')
sun_file_path = sun_path + '/' + sun_file_name
File.open(sun_file_path,"w") do |sun_file|
	sun_file.write(sun_direction)
end

#UPDATE LOG FILE
log = '0'
log_file_path = log_path + '/' + log_file_name
File.open(log_file_path,"w") do |log_file|
	log_file.write(log)
	#puts 'write: ' + log
end

#START BLENDER WITH A BATCH FILE
batch_file_path = 'file:///' + batch_path + '/' + batch_file_name
UI.openURL(batch_file_path)

#WAIT FOR BLENDER TO FINISH
timer_count = 0
timer = UI.start_timer(1, true) { 
	File.open(log_file_path,"r") do |log_file|	
		log = log_file.gets()
		#puts 'read: ' + log
		if log == '1'
			UI.stop_timer(timer) 
			
			#IMPORT PROCESSED COLLADA FILE
			status = model.import model_file_path
		elsif timer_count == 60
			UI.stop_timer(timer) 
		end
	end
	timer_count = timer_count + 1
}


